import UIKit
import Flutter
import GoogleMobileAds
import AppTrackingTransparency
import AdSupport

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
    override func application(
        _ application: UIApplication,
        didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
    ) -> Bool {
        GeneratedPluginRegistrant.register(with: self)
        GADMobileAds.sharedInstance().start(completionHandler: nil)
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.5) {self.requestIDFA()}
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
    }
    func requestIDFA() {
        if #available(iOS 14, *) {
            ATTrackingManager.requestTrackingAuthorization(completionHandler: { status in
                //GADMobileAds.sharedInstance().start(completionHandler: nil)
                GADMobileAds.sharedInstance().requestConfiguration.testDeviceIdentifiers = [ GADSimulatorID ]
            })
        } 
        else {
            GADMobileAds.sharedInstance().start(completionHandler: nil)
        }
    }
}
